/*
   ******************************************************************************

   LIBGCP: extension stubs

   Copyright (C) 2000 Christoph Egger   [Christoph_Egger@t-online.de]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

   ******************************************************************************
 */

#include <ggi/internal/gcp.h>


/* Color palette manipulation
 */

/* RGBA */
gcp_pixel gcpMapRGBAColor(ggi_visual_t vis, gcp_RGBAcolor *col)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->MapRGBAColor(vis, col);
}


int gcpUnmapRGBAPixel(ggi_visual_t vis, gcp_pixel pixel, gcp_RGBAcolor *col)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->UnmapRGBAPixel(vis, pixel, col);
}


int gcpPackRGBAColors(ggi_visual_t vis,void *buf,gcp_RGBAcolor *cols,int len)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->PackRGBAColors(vis, buf, cols, len);
}


int gcpUnpackRGBAPixels(ggi_visual_t vis,void *buf,gcp_RGBAcolor *cols,int len)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->UnpackRGBAPixels(vis, buf, cols, len);
}


int gcpGetRGBAPalette(ggi_visual_t vis,int s,int len,gcp_RGBAcolor *cmap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetRGBAPalette(vis, s, len, cmap);
}


int gcpSetRGBAPalette(ggi_visual_t vis,int s,int len,gcp_RGBAcolor *cmap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetRGBAPalette(vis, s, len, cmap);
}




/* YUV */
gcp_pixel gcpMapYUVColor(ggi_visual_t vis, gcp_YUVcolor *col)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->MapYUVColor(vis, col);
}


int gcpUnmapYUVPixel(ggi_visual_t vis, gcp_pixel pixel, gcp_YUVcolor *col)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->UnmapYUVPixel(vis, pixel, col);
}



int gcpPackYUVColors(ggi_visual_t vis,void *buf,gcp_YUVcolor *cols,int len)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->PackYUVColors(vis, buf, cols, len);
}


int gcpUnpackYUVPixels(ggi_visual_t vis,void *buf,gcp_YUVcolor *cols,int len)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->UnpackYUVPixels(vis, buf, cols, len);
}



int gcpGetYUVPalette(ggi_visual_t vis,int s,int len,gcp_YUVcolor *cmap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetYUVPalette(vis, s, len, cmap);
}


int gcpSetYUVPalette(ggi_visual_t vis,int s,int len,gcp_YUVcolor *cmap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetYUVPalette(vis, s, len, cmap);
}




/* CMYK */
gcp_pixel gcpMapCMYKColor(ggi_visual_t vis, gcp_CMYKcolor *col)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->MapCMYKColor(vis, col);
}


int gcpUnmapCMYKPixel(ggi_visual_t vis, gcp_pixel pixel, gcp_CMYKcolor *col)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->UnmapCMYKPixel(vis, pixel, col);
}



int gcpPackCMYKColors(ggi_visual_t vis,void *buf,gcp_CMYKcolor *cols,int len)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->PackCMYKColors(vis, buf, cols, len);
}


int gcpUnpackCMYKPixels(ggi_visual_t vis,void *buf,gcp_CMYKcolor *cols,int len)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->UnpackCMYKPixels(vis, buf, cols, len);
}



int gcpGetCMYKPalette(ggi_visual_t vis,int s,int len,gcp_CMYKcolor *cmap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetCMYKPalette(vis, s, len, cmap);
}


int gcpSetCMYKPalette(ggi_visual_t vis,int s,int len,gcp_CMYKcolor *cmap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetCMYKPalette(vis, s, len, cmap);
}




/* HSV */
gcp_pixel gcpMapHSVColor(ggi_visual_t vis, gcp_HSVcolor *col)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->MapHSVColor(vis, col);
}


int gcpUnmapHSVPixel(ggi_visual_t vis, gcp_pixel pixel, gcp_HSVcolor *col)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->UnmapHSVPixel(vis, pixel, col);
}



int gcpPackHSVColors(ggi_visual_t vis,void *buf,gcp_HSVcolor *cols,int len)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->PackHSVColors(vis, buf, cols, len);
}


int gcpUnpackHSVPixels(ggi_visual_t vis,void *buf,gcp_HSVcolor *cols,int len)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->UnpackHSVPixels(vis, buf, cols, len);
}



int gcpGetHSVPalette(ggi_visual_t vis,int s,int len,gcp_HSVcolor *cmap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetHSVPalette(vis, s, len, cmap);
}


int gcpSetHSVPalette(ggi_visual_t vis,int s,int len,gcp_HSVcolor *cmap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetHSVPalette(vis, s, len, cmap);
}




int gcpSetColorfulPalette(ggi_visual_t vis)
{
	return ggiSetColorfulPalette(vis);
}




/* Gamma map manipulation
 */

/* RGBA */
int gcpGetRGBAGamma(ggi_visual_t vis,ggi_float *r,ggi_float *g,ggi_float *b)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetRGBAGamma(vis, r, g, b);
}


int gcpSetRGBAGamma(ggi_visual_t vis,ggi_float r,ggi_float g,ggi_float b)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetRGBAGamma(vis, r, g, b);
}



int gcpGetRGBAGammaMap(ggi_visual_t vis,int s,int len,gcp_RGBAcolor *gammamap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetRGBAGammaMap(vis, s, len, gammamap);
}


int gcpSetRGBAGammaMap(ggi_visual_t vis,int s,int len,gcp_RGBAcolor *gammamap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetRGBAGammaMap(vis, s, len, gammamap);
}




/* YUV */
int gcpGetYUVGamma(ggi_visual_t vis,ggi_float *y,ggi_float *u,ggi_float *v)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetYUVGamma(vis, y, u, v);
}


int gcpSetYUVGamma(ggi_visual_t vis,ggi_float y,ggi_float u,ggi_float v)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetYUVGamma(vis, y, u, v);
}



int gcpGetYUVGammaMap(ggi_visual_t vis,int s,int len,gcp_YUVcolor *gammamap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetYUVGammaMap(vis, s, len, gammamap);
}


int gcpSetYUVGammaMap(ggi_visual_t vis,int s,int len,gcp_YUVcolor *gammamap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetYUVGammaMap(vis, s, len, gammamap);
}




/* CMYK */
int gcpGetCMYKGamma(ggi_visual_t vis,ggi_float *c,ggi_float *m,ggi_float *y,ggi_float *k)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetCMYKGamma(vis, c, m, y, k);
}


int gcpSetCMYKGamma(ggi_visual_t vis,ggi_float c,ggi_float m,ggi_float y,ggi_float k)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetCMYKGamma(vis, c, m, y, k);
}



int gcpGetCMYKGammaMap(ggi_visual_t vis,int s,int len,gcp_CMYKcolor *gammamap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetCMYKGammaMap(vis, s, len, gammamap);
}


int gcpSetCMYKGammaMap(ggi_visual_t vis,int s,int len,gcp_CMYKcolor *gammamap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetCMYKGammaMap(vis, s, len, gammamap);
}




/* HSV */
int gcpGetHSVGamma(ggi_visual_t vis,ggi_float *h,ggi_float *s,ggi_float *v)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetHSVGamma(vis, h, s, v);
}


int gcpSetHSVGamma(ggi_visual_t vis,ggi_float h,ggi_float s,ggi_float v)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetHSVGamma(vis, h, s, v);
}



int gcpGetHSVGammaMap(ggi_visual_t vis,int s,int len,gcp_HSVcolor *gammamap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetHSVGammaMap(vis, s, len, gammamap);
}


int gcpSetHSVGammaMap(ggi_visual_t vis,int s,int len,gcp_HSVcolor *gammamap)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetHSVGammaMap(vis, s, len, gammamap);
}





/* Blending manipulation
 */

/* Color blending */
gcp_pixel gcpBlendColor(ggi_visual_t vis,
			const gcp_pixel *pix1,
			const gcp_pixel *pix2, uint16 alpha)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->BlendColor(vis, pix1, pix2, alpha);
}





/* Lightning manipulation
 */

gcp_pixel gcpSetIntensity(ggi_visual_t vis, const gcp_pixel *pix1, const gcp_pixel *light_color)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->SetIntensity(vis, pix1, light_color);
}


gcp_pixel gcpGetIntensity(ggi_visual_t vis, const gcp_pixel *pix1, const gcp_pixel *pix2)
{
	gcppriv *priv = LIBGGI_GCPEXT(vis);

	return priv->GetIntensity(vis, pix1, pix2);
}
